from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Directory, Boolean, Int, File, String

Average_Nucleotide_Identity_Py_V0_1_0 = CommandToolBuilder(tool="average_nucleotide_identity.py", base_command=["average_nucleotide_identity.py"], inputs=[ToolInput(tag="in_outdir", input_type=Directory(optional=True), prefix="--outdir", doc=InputDocumentation(doc="Output directory (required)")), ToolInput(tag="in_in_dir", input_type=Directory(optional=True), prefix="--indir", doc=InputDocumentation(doc="Input directory name (required)")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Give verbose output")), ToolInput(tag="in_force", input_type=Boolean(optional=True), prefix="--force", doc=InputDocumentation(doc="Force file overwriting")), ToolInput(tag="in_frag_size", input_type=Int(optional=True), prefix="--fragsize", doc=InputDocumentation(doc="Sequence fragment size for ANIb (default 1020)")), ToolInput(tag="in_log_file", input_type=File(optional=True), prefix="--logfile", doc=InputDocumentation(doc="Logfile location")), ToolInput(tag="in_skip_nuc_mer", input_type=Boolean(optional=True), prefix="--skip_nucmer", doc=InputDocumentation(doc="Skip NUCmer runs, for testing (e.g. if output already\npresent)")), ToolInput(tag="in_skip_blastn", input_type=Boolean(optional=True), prefix="--skip_blastn", doc=InputDocumentation(doc="Skip BLASTN runs, for testing (e.g. if output already\npresent)")), ToolInput(tag="in_no_clobber", input_type=Boolean(optional=True), prefix="--noclobber", doc=InputDocumentation(doc="Don't nuke existing files")), ToolInput(tag="in_no_compress", input_type=Boolean(optional=True), prefix="--nocompress", doc=InputDocumentation(doc="Don't compress/delete the comparison output")), ToolInput(tag="in_graphics", input_type=Boolean(optional=True), prefix="--graphics", doc=InputDocumentation(doc="Generate heatmap of ANI")), ToolInput(tag="in_g_format", input_type=File(optional=True), prefix="--gformat", doc=InputDocumentation(doc="Graphics output format(s) [pdf|png|jpg|svg] (default\npdf,png,eps meaning three file formats)")), ToolInput(tag="in_g_method", input_type=String(optional=True), prefix="--gmethod", doc=InputDocumentation(doc="Graphics output method (default mpl)")), ToolInput(tag="in_labels", input_type=File(optional=True), prefix="--labels", doc=InputDocumentation(doc="Path to file containing sequence labels")), ToolInput(tag="in_classes", input_type=File(optional=True), prefix="--classes", doc=InputDocumentation(doc="Path to file containing sequence classes")), ToolInput(tag="in_method", input_type=String(optional=True), prefix="--method", doc=InputDocumentation(doc="ANI method (default ANIm)")), ToolInput(tag="in_scheduler", input_type=String(optional=True), prefix="--scheduler", doc=InputDocumentation(doc="Job scheduler (default multiprocessing, i.e. locally)")), ToolInput(tag="in_workers", input_type=Int(optional=True), prefix="--workers", doc=InputDocumentation(doc="Number of worker processes for multiprocessing\n(default zero, meaning use all available cores)")), ToolInput(tag="in_sge_group_size", input_type=Int(optional=True), prefix="--SGEgroupsize", doc=InputDocumentation(doc="Number of jobs to place in an SGE array group (default\n10000)")), ToolInput(tag="in_sge_args", input_type=String(optional=True), prefix="--SGEargs", doc=InputDocumentation(doc="Additional arguments for qsub")), ToolInput(tag="in_max_match", input_type=Boolean(optional=True), prefix="--maxmatch", doc=InputDocumentation(doc="Override MUMmer to allow all NUCmer matches")), ToolInput(tag="in_nuc_mer_exe", input_type=File(optional=True), prefix="--nucmer_exe", doc=InputDocumentation(doc="Path to NUCmer executable")), ToolInput(tag="in_filter_exe", input_type=File(optional=True), prefix="--filter_exe", doc=InputDocumentation(doc="Path to delta-filter executable")), ToolInput(tag="in_blastn_exe", input_type=File(optional=True), prefix="--blastn_exe", doc=InputDocumentation(doc="Path to BLASTN+ executable")), ToolInput(tag="in_make_blast_db_exe", input_type=File(optional=True), prefix="--makeblastdb_exe", doc=InputDocumentation(doc="Path to BLAST+ makeblastdb executable")), ToolInput(tag="in_blast_all_exe", input_type=File(optional=True), prefix="--blastall_exe", doc=InputDocumentation(doc="Path to BLASTALL executable")), ToolInput(tag="in_format_db_exe", input_type=File(optional=True), prefix="--formatdb_exe", doc=InputDocumentation(doc="Path to BLAST formatdb executable")), ToolInput(tag="in_write_excel", input_type=Boolean(optional=True), prefix="--write_excel", doc=InputDocumentation(doc="Write Excel format output tables")), ToolInput(tag="in_re_render", input_type=Boolean(optional=True), prefix="--rerender", doc=InputDocumentation(doc="Rerender graphics output without recalculation")), ToolInput(tag="in_subsample", input_type=Int(optional=True), prefix="--subsample", doc=InputDocumentation(doc="Subsample a percentage [0-1] or specific number (1-n)\nof input sequences")), ToolInput(tag="in_seed", input_type=String(optional=True), prefix="--seed", doc=InputDocumentation(doc="Set random seed for reproducible subsampling.")), ToolInput(tag="in_job_prefix", input_type=String(optional=True), prefix="--jobprefix", doc=InputDocumentation(doc="Prefix for SGE jobs (default ANI).\n"))], outputs=[ToolOutput(tag="out_outdir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_outdir", type_hint=File()), doc=OutputDocumentation(doc="Output directory (required)")), ToolOutput(tag="out_g_format", output_type=File(optional=True), selector=InputSelector(input_to_select="in_g_format", type_hint=File()), doc=OutputDocumentation(doc="Graphics output format(s) [pdf|png|jpg|svg] (default\npdf,png,eps meaning three file formats)"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Average_Nucleotide_Identity_Py_V0_1_0().translate("wdl", allow_empty_container=True)

